/*
    Copyright (c) 2002 Florian Wesch <fw@dividuum.de>. All Rights Reserved.     
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
*/    


#ifndef BRAINFUCK_H
#define BRAINFUCK_H

typedef unsigned char   BFINST;         // Brainfuck instruction datatype
typedef unsigned char   BFVALUE;        // Brainfuck memory datatype
typedef int             BFADDR;         // Brainfuck address datatype

#define INVALIDADDR     (-1)

// Brainfuck Opcodes
#define BF_OPINCV '+'
#define BF_OPLOOPS '['
#define BF_OPDECV '-'
#define BF_OPLOOPE ']'
#define BF_OPINCP '>'
#define BF_OPDECP '<'
#define BF_OPOUT '.'
#define BF_OPIN ','


// Auch Brainfuck braucht Limits :-P
#define MAXLOOPLEVEL 100
#define MAXMEMSIZE   10000

#endif // BRAINFUCK_H
