/*
    Copyright (c) 2002 Florian Wesch <fw@dividuum.de>. All Rights Reserved.     
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
*/    


#ifndef SYMTABLE_H
#define SYMTABLE_H

#include <string.h>
#include <stdlib.h>
#include "brainfuck.h"

typedef struct SymbolStruct {
    char*       name;
    BFADDR      mempos;
    int         size;
    struct SymbolStruct *next;
} Symbol;

typedef struct {
    BFADDR lastmempos;
    Symbol *first;
} SymbolTable;

SymbolTable *STInit();
void    NewSymbol(SymbolTable *st, char *name, int size);
Symbol *GetSymbol(SymbolTable *st, char *name);
void    SymbolGrowSize(SymbolTable *st, char *name, int possible_new_size);
void    STAssignLocation(SymbolTable *st);
BFADDR  GetSymLoc(SymbolTable *st, char *name);
void    STDump(SymbolTable *st);

#endif
